#include "StdAfx.h"
#include "ChatMainViewElementList.h"
#include "ChatDlg.h"
#include "UIStickerElement.h"
#include "UISysMsgElement.h"
#include "UIChatFileElement.h"
#include "FTImageMap.h"
#include "XHyperLink.h"
#include "FileTraslateAbnormalHandler.h"
#include "UserImageActor.h"
#include "UIUserJoinElement.h"
#include "..\JpnPack\Resource.h"
#include "RecentRecord.h"
#include <ftlWindow.h>
#define SECOND_OF_DAY 86400	//24 * 60 * 60
#define RECTENT_MESSAGE_FONT_HEIGHT	8

#ifdef _DEBUG
#define PAGE_SIZE	20
#else
#define PAGE_SIZE	20
#endif

IMPLEMENT_DYNAMIC(CChatMainViewElementList, CWnd)

CChatMainViewElementList::CChatMainViewElementList(CChatDlg* parentChatDlg)
{
	//m_pImgBG = NULL;
	m_nScrollOneSize = DEF_CHAT_SCROLL_SIZE;
	m_crChatBG = DEF_CHATBG_COLOR;
	m_crMyChatBG = DEF_MYCHATBG_COLOR;
	m_nSplitterMove = 0;
	//m_bLButtonDown = FALSE;
	m_bMouseSelection = FALSE;
	m_ptSelectionStart.SetPoint(-1, -1);
	m_nChatDisplayType = CHAT_BUBBLE;
	m_strRecentMsg = _T("");
	m_dwRecentTick = 0;
	m_bMouseInRecentMsgRect = false;
	m_pLastChatItem = NULL;
	m_pChatDlg = parentChatDlg;
	m_nRecentMessageCursor = 0;
	m_bRecentMessagePress = FALSE;
	m_bMouseTrack = true;

	m_rcRecentMessageBottom.SetRectEmpty();
	m_rcRecentMsg.SetRectEmpty();
	m_pDownloadImage = NULL;
	//m_pReDownloadImage = NULL;
	m_pDownloadedImage = NULL;
	m_pCancelDownloadImage = NULL;
	m_pCancelSendImage = NULL;

	m_pImgRecentMessage = NULL;
	m_pImageDivider = NULL;

	m_hWndToolTip = NULL;
	ZeroMemory(&m_ToolInfo,sizeof(m_ToolInfo));
	ZeroMemory(m_pImgMyBubble,sizeof(m_pImgMyBubble));
	ZeroMemory(m_pImgRecentMessageBK,sizeof(m_pImgRecentMessageBK));
	ZeroMemory(m_pImageUserJoin,sizeof(m_pImageUserJoin));
	ZeroMemory(m_pImageUserLeave,sizeof(m_pImageUserLeave));
	ZeroMemory(m_pImageBubbleBottomForSendProcess,sizeof(m_pImageBubbleBottomForSendProcess));
	ZeroMemory(m_pImageBubbleBottomForRecvProcess,sizeof(m_pImageBubbleBottomForRecvProcess));
	ZeroMemory(m_pImgYourProgress,sizeof(m_pImgYourProgress));
	ZeroMemory(m_pImgMyProgress,sizeof(m_pImgMyProgress));
	ZeroMemory(m_pImgOtherProgress,sizeof(m_pImgOtherProgress));
	ZeroMemory(m_pImgSendStatus,sizeof(m_pImgSendStatus));
	ZeroMemory(m_pImgOtherBubble,sizeof(m_pImgOtherBubble));



	for (int i = 0; i < 3; i++)
	{
		m_rcRecentMessage[i].SetRectEmpty();
	}

	m_nStartSelTextIndex = -1;
	m_nEndSelTextIndex = -1;
	m_bMouseDown = FALSE;
	
}

CChatMainViewElementList::~CChatMainViewElementList(void)
{
	//for (ImageByPathMap::iterator iter = m_imageByPathMap.begin(); 
	//	iter != m_imageByPathMap.end();
	//	++iter)
	//{
	//	Image* pImage = iter->second;
	//	delete pImage;
	//}
	//m_imageByPathMap.clear();


    ASSERT(NULL == m_pDownloadImage);
    ASSERT(NULL == m_pDownloadedImage);
    ASSERT(NULL == m_pCancelDownloadImage);
    ASSERT(NULL == m_pCancelSendImage);
    ASSERT(NULL == m_pImgRecentMessage);
    ASSERT(NULL == m_pImageDivider);
    ASSERT(NULL == m_hWndToolTip);

    //fix lint 1540
    SAFE_DELETE(m_pDownloadImage);
    SAFE_DELETE(m_pDownloadedImage);
    SAFE_DELETE(m_pCancelDownloadImage);
    SAFE_DELETE(m_pCancelSendImage);
    SAFE_DELETE(m_pImgRecentMessage);
    SAFE_DELETE(m_pImageDivider);
    m_hWndToolTip = NULL;
}

BEGIN_MESSAGE_MAP(CChatMainViewElementList, CWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_CHAR()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSELEAVE()
	ON_WM_MOUSEHOVER()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_SIZE()
	//ON_WM_VSCROLL()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEWHEEL()
	ON_MESSAGE(UM_SPLITTER_MOVE, &CChatMainViewElementList::OnUmSplitterMove)
	ON_COMMAND(ID_CHAT_MAIN_COPY, &CChatMainViewElementList::OnMenuMainCopy)
	//ON_MESSAGE(UM_ELEMENT_UPDATE, &CChatMainViewElementList::OnElementUpdate)
	ON_MESSAGE(WM_VSCROLL_VIEW, &CChatMainViewElementList::OnVscrollView)
	ON_WM_TIMER()
END_MESSAGE_MAP()

// void CChatMainViewElementList::SetChatMsgResult(UINT nTid, CHAT_ITEM_STATE state)
// {
// 	CString strCurrentID = m_pChatModel->GetMyID();
// 	BOOL bRedraw = FALSE;
// 	{
// 		CSingleLock l(&m_csUIElement, TRUE);
// 		for (size_t i = 0; i < m_vcUIElement.size(); i++)
// 		{
// 			LPChatItemInfo pInfo = m_vcUIElement[i]->GetChatItemInfo();
// 			if (pInfo->nTid == nTid && pInfo->strUserID.CompareNoCase(strCurrentID) == 0)
// 			{
// 				CChatItem *pChatItem = m_vcUIElement[i]->GetChatItem();
// 				if (pChatItem)
// 				{
// 					pChatItem->SetState(state);
// 				}
// 				bRedraw = TRUE;
// 				break;
// 			}
// 		}
// 	}
// 
// 	if (bRedraw)
// 	{
// 		CalcUIElementRect();
// 		PostMessage(UM_ELEMENT_UPDATE, ELEMENT_UPDATE_UNIT);
// 	}
// }

void CChatMainViewElementList::ShowRecentMessage()
{
	BOOL bShowMsg = m_rmSqlite.IsExistRecentMessage(m_pChatModel->GetRoomID(),m_pChatModel->GetChatItemCount());
	if (bShowMsg != m_bShowRecentMsg)
	{
		m_bShowRecentMsg = bShowMsg;
		CalcUIElementRect();
	}

}

BOOL CChatMainViewElementList::AddRecentChatMessamge(LPChatItemInfo pChatItemInfo)
{
	CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
	CSingleLock l(&m_csUIElement, TRUE);

	CString strMyUserId = g_pMessengerActor->GetUserID();
	if(strMyUserId == pChatItemInfo->strUserID)
	{
		pChatItemInfo->strUserName = m_pChatModel->GetMyName();
		pChatItemInfo->strNameTalkName = m_pChatModel->GetMyTalkName();
	}
	else
	{
		if (!pChatItemInfo->strUserID.IsEmpty())
		{
			CString strUserName = m_pChatModel->GetChatUserName(pChatItemInfo->strUserID);
			CString strNickName = m_pChatModel->GetChatUserNickName(pChatItemInfo->strUserID);

			if (!strUserName.IsEmpty())
			{
				pChatItemInfo->strUserName = strUserName;
			}
			
			if (!strNickName.IsEmpty())
			{
				pChatItemInfo->strNameTalkName =  strNickName;
			}
		}
	}
	
	//pChatItemInfo->cf =  m_pChatModel->GetSendChatViewUserFont();
	CChatItem* pChItem = AllocChatItem(pChatItemInfo);
	if (!pChItem)
	{
		return FALSE;
	}

	
	const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo(pChatItemInfo->strUserID);
	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(pChatItemInfo->strUserID);
	if(pUser == NULL)
	{
		pUser = g_pMessengerActor->GetBuddyInfoFromPersist(pChatItemInfo->strUserID);
	}

	if(pUser != NULL && pData != NULL)
	{
		CString strToolTip;
		pChItem->UpdateUserStatus(pUser->GetStatus());
		//strToolTip.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pUser->GetName(), GetPresenceTip(pChItem->gets), pData->strEmail.c_str());
		pChItem->SetToolTip(strToolTip);
		pChItem->SetUserEmail(pData->strEmail.c_str());
	}

	CChatItem* pChItemLast = NULL;
	int nCntItem = m_pChatModel->GetChatItemCount();
	if (nCntItem > 0)
		pChItemLast = (CChatItem*)m_pChatModel->GetChatItem(nCntItem - 1);

	if (pChItem->IsSysType() && pChItem->IsNullMsg())
	{
		delete pChItem;
		pChItem = NULL;

		return FALSE;
	}

	UIElement* pUIElement = CreateUIElementByChatItem(pChItem);
	if (pUIElement == NULL)
	{
		delete pChItem;
		pChItem = NULL;
		return FALSE;
	}

	pUIElement->EnableRetryButton(FALSE);
	m_vcUIElement.insert(m_vcUIElement.begin(), pUIElement);
	m_pChatModel->AddRecentChatItemToArray(pChItem);

	/*if (m_m_pChatDlg->IsScrollLocked())
	{
		m_strNewMessageUser = pChItem->GetChatItemInfo()->strUserName;
		m_strRecentMsg = pChItem->GetNewMessage();

		m_pLastChatItem = pChItem;
		m_dwRecentTick = GetTickCount();
		SetTimer(CHATMAIN_TIMER, 1000, NULL);
	}*/

	//PostMessage(UM_ELEMENT_UPDATE, ELEMENT_UPDATE_SCROLL);

	return TRUE;
}

void CChatMainViewElementList::ResetChatItem(UINT uTid)
{
	BOOL bRedraw = FALSE;
	int nIndex = -1;
	CSingleLock l(&m_csUIElement, TRUE);
	for (size_t i = 0; i < m_vcUIElement.size(); i++)
	{
		LPChatItemInfo pInfo = m_vcUIElement[i]->GetChatItemInfo();
		if (pInfo->nTid == uTid && m_pChatModel->GetMyID().CompareNoCase(pInfo->strUserID) == 0)
		{
			CChatItem *pChatItem = m_vcUIElement[i]->GetChatItem();
			if (pChatItem)
			{
				if (pInfo->eMsgGB == CHAT_MSG_FTP)
				{
					pChatItem->SetMsgStatus(sInvalid);
				}
				else
				{
					pChatItem->SetMsgStatus(CMS_INVALID);
				}

				pChatItem->ResetFailCount();
				pChatItem->SetSucceedCount(0);
			}
			bRedraw = TRUE; 
			nIndex = i;
			break;
		}
	}

	l.Unlock();

	if (bRedraw)
	{
		UpdateElementStateByIndex(nIndex);
		UpdateView();
	}
}

void CChatMainViewElementList::UpdateElementStateByPointer(UIElement *e)
{
	CSingleLock l(&m_csUIElement, TRUE);
	for (int i = (int)m_vcUIElement.size() - 1; i >= 0; i--)
	{
		if (m_vcUIElement[i] == e)
		{
			UpdateElementStateByIndex(i);
			break;
		}
	}

	//l.Unlock();
}

void CChatMainViewElementList::UpdateElementStateByIndex(int nIndex)
{
	CSingleLock l(&m_csUIElement, TRUE);
	CSize szOffset(0, 0);
	if (nIndex >= 0 && nIndex < (int)m_vcUIElement.size())
	{
		DWORD dwFlags = CalcItemFlag(nIndex);
		if (nIndex == 0)
		{
			szOffset = CalcRecentMessageButton();
			szOffset.cy += CHAT_ELEMENTLIST_BOTTOM;
		}
		else
		{
			szOffset.cx = 0;
			szOffset.cy = m_vcUIElement[nIndex - 1]->GetElementRect().bottom;
		}

		m_vcUIElement[nIndex]->CalcSize(szOffset, dwFlags);
	}

	//l.Unlock();
}

SIZE CChatMainViewElementList::UpdateElementRect(int nIndex)
{
	CSingleLock l(&m_csUIElement, TRUE);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	BOOL bCaclAllItem = FALSE;

	CSize szViewSize(0, 0);
	CSize szOffset(0, 0);
	if (nIndex >= 0 && nIndex < m_vcUIElement.size())
	{
		DWORD dwFlags = CalcItemFlag(nIndex);
		if (nIndex == 0)
		{
			szOffset = CalcRecentMessageButton();
			szOffset.cy += CHAT_ELEMENTLIST_BOTTOM;
		}
		else
		{
			szOffset.cx = 0;
			szOffset.cy = m_vcUIElement[nIndex - 1]->GetElementRect().bottom;
		}
		
		CSize size = m_vcUIElement[nIndex]->CalcSize(szOffset, dwFlags);

		BOOL bPrevScrollBarVisible = m_wndScrollBar.IsWindowVisible();
		BOOL bNowScrollBarVisible = FALSE;
		if (szOffset.cy + size.cy > rcClient.Height())
		{
			bNowScrollBarVisible = TRUE;
		}

		m_wndScrollBar.ShowWindow(bNowScrollBarVisible?true:false,false);

		// when the scroll bar is visible/invisible,need to calulate all item rectangle
		if (bNowScrollBarVisible == bPrevScrollBarVisible)
		{
			szViewSize = m_szTotalViewSize + size;	//total view height should add the item height.
		}
		else
		{
			bCaclAllItem = TRUE;
		}
	}

	l.Unlock();

	// when the scroll bar is visible/invisible,need to calulate all item rectangle
	if (bCaclAllItem)
	{
		szViewSize = CalcUIElementRect();
	}

	UpdateScrollInfo();
	
	return szViewSize;

}

void CChatMainViewElementList::SetViewSize(SIZE &sz)
{
	m_szTotalViewSize = sz;

}

UIElement* CChatMainViewElementList::AddChatItem( LPChatItemInfo pChatItemInfo, bool bRestore )
{
	//CChatModelAssistant ChatModelAssistant(m_pChatModel);

	UIElement *pUIElement = NULL;
	CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
	CSingleLock l(&m_csUIElement, TRUE);

	if (!pChatItemInfo->strUserID.IsEmpty() && -1 != m_pChatModel->GetChatItemIndex(pChatItemInfo->strUserID,pChatItemInfo->nTid))
	{
		return NULL;
	}

	CChatItem* pChItem = AllocChatItem(pChatItemInfo);

	if (!pChItem)
	{
		return NULL;
	}
	
	pChItem->SetGroupUserChat(m_pChatModel->IsGroupRoom());

	const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo(pChatItemInfo->strUserID);
	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(pChatItemInfo->strUserID);
	if(pUser == NULL)
	{
		pUser = g_pMessengerActor->GetBuddyInfoFromPersist(pChatItemInfo->strUserID);
	}

	if(pUser != NULL && pData != NULL)
	{
		CString strToolTip;
		pChItem->UpdateUserStatus(pUser->GetStatus());
		//strToolTip.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pUser->GetName(), GetPresenceTip(pChItem->gets), pData->strEmail.c_str());
		pChItem->SetToolTip(strToolTip);
		pChItem->SetUserEmail(pData->strEmail.c_str());
	}
	

	CChatItem* pChItemLast = NULL;
	int nCntItem = m_pChatModel->GetChatItemCount();
	if (nCntItem > 0)
		pChItemLast = (CChatItem*)m_pChatModel->GetChatItem(nCntItem - 1);

	if ((pChItem->IsSysType() || pChItem->IsJoinOrLeaveType()) && pChItem->IsNullMsg())
	{
		delete pChItem;
		pChItem = NULL;

		return NULL;
	}
	
	pUIElement = CreateUIElementByChatItem(pChItem);
	if (pUIElement == NULL)
	{
		delete pChItem;
		pChItem = NULL;
		return NULL;
	}

	
	m_vcUIElement.push_back(pUIElement);
	m_pChatModel->AddChatItemToArray(pChItem);

	if (m_pChatDlg->IsScrollLocked())
	{
		m_strNewMessageUser = pChItem->GetChatItemInfo()->strUserName;
		m_strRecentMsg = pChItem->GetNewMessage();

		m_pLastChatItem = pChItem;
		m_dwRecentTick = GetTickCount();
		SetTimer(CHATMAIN_TIMER, 1000, NULL);
	}

	l.Unlock();
	m_szTotalViewSize = UpdateElementRect(m_vcUIElement.size() - 1);
	if (!m_pChatDlg->IsScrollLocked())
	{
		ScrollToLastchatItem();
	}

	if(bRestore)
	{
		m_rmSqlite.AddChatItemInfo(m_pChatModel->GetRoomID(), pChatItemInfo);
	}
	
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	return pUIElement;

	
}


BOOL CChatMainViewElementList::AddRecentFileMessamge(TranslateFileInfoPtr& pTranslateFileInfo)
{
	ChatItemInfo stItemInfo;
	stItemInfo.eMsgGB = CHAT_MSG_FTP;
	stItemInfo.strUserID = pTranslateFileInfo->m_strSenderID;
// 	if(stItemInfo.strUserID.IsEmpty())
// 	{
// 		stItemInfo.strUserID = m_pChatModel->GetMyID();
// 	}
// 	stItemInfo.strUserName = m_pChatModel->GetChatUserName( pTranslateFileInfo->m_strSenderID);
// 	stItemInfo.strNameTalkName = m_pChatModel->GetChatUserNickName(pTranslateFileInfo->m_strSenderID);
	if(stItemInfo.strUserID.CompareNoCase(m_pChatModel->GetMyID()) == 0)
	{
		stItemInfo.strUserName = m_pChatModel->GetMyName();
		stItemInfo.strNameTalkName = m_pChatModel->GetMyTalkName();
	}
	else
	{
		if (!stItemInfo.strUserID.IsEmpty())
		{
			CString strUserName = m_pChatModel->GetChatUserName(stItemInfo.strUserID);
			CString strNickName = m_pChatModel->GetChatUserNickName(stItemInfo.strUserID);

			if (!strUserName.IsEmpty())
			{
				stItemInfo.strUserName = strUserName;
			}

			if (!strNickName.IsEmpty())
			{
				stItemInfo.strNameTalkName =  strNickName;
			}
		}
	}

	stItemInfo.time = pTranslateFileInfo->m_tmTime;
	stItemInfo.nTid = pTranslateFileInfo->m_TidRequestFileTranslate;
	stItemInfo.nMsgStatus = pTranslateFileInfo->m_Status;
	if( !pTranslateFileInfo)
	{
		return FALSE;
	}

	CChatFileItem* pChItem = (CChatFileItem*)AllocChatItem(&stItemInfo);
	if (!pChItem)
	{
		return FALSE;
	}

	const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo(stItemInfo.strUserID);
	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(stItemInfo.strUserID);
	if(pUser == NULL)
	{
		pUser = g_pMessengerActor->GetBuddyInfoFromPersist(stItemInfo.strUserID);
	}

	if(pUser != NULL && pData != NULL)
	{
		CString strToolTip;
		pChItem->UpdateUserStatus(pUser->GetStatus());
		//strToolTip.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pUser->GetName(), GetPresenceTip(pChItem->gets), pData->strEmail.c_str());
		pChItem->SetToolTip(strToolTip);
		pChItem->SetUserEmail(pData->strEmail.c_str());
	}

	pChItem->SetTranslateFileInfo(pTranslateFileInfo);
	CChatItem* pChItemLast = NULL;
	int nCntItem = m_pChatModel->GetChatItemCount();

	if (nCntItem > 0)
		pChItemLast = (CChatItem*)m_pChatModel->GetChatItem(nCntItem - 1);

	UIElement* pUIElement = CreateUIElementByChatItem(pChItem);
	if (pUIElement == NULL)
	{
		delete pChItem;
		pChItem = NULL;
		return FALSE;
	}

	pUIElement->EnableRetryButton(FALSE);
	ITranslateItemCallBack* pTransCallBack = dynamic_cast<ITranslateItemCallBack*>(pUIElement);
	ASSERT(pTransCallBack);
	pTranslateFileInfo->SetTranslateCallback(pTransCallBack);

	m_vcUIElement.insert(m_vcUIElement.begin(), pUIElement);
	m_pChatModel->AddRecentChatItemToArray(pChItem);

	//ScrollToChatItem()
	/*if (m_pChatDlg->IsScrollLocked())
	{
		m_strNewMessageUser = pChItem->GetChatItemInfo()->strUserName;
		m_strRecentMsg = pChItem->GetNewMessage();
		m_dwRecentTick = GetTickCount();
		SetTimer(CHATMAIN_TIMER, 1000, NULL);
	}*/

	//PostMessage(UM_ELEMENT_UPDATE, ELEMENT_UPDATE_SCROLL);

	return TRUE;
}

UIElement* CChatMainViewElementList::AddTranslateFileItem( LPChatItemInfo pChatItemInfo, TranslateFileInfoPtr& pTranslateFileInfo, bool bRestore)
{
	CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
	CSingleLock l(&m_csUIElement, TRUE);
	
	ASSERT(pTranslateFileInfo == true);
	if( !pTranslateFileInfo)
	{
		return NULL;
	}

	if (!pTranslateFileInfo->m_strSenderID.IsEmpty() 
		&& -1 != m_pChatModel->GetChatItemIndex(pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate))
	{
		return NULL;
	}


	CChatFileItem* pChItem = (CChatFileItem*)AllocChatItem(pChatItemInfo);
	if (!pChItem)
	{
		return NULL;
	}

	const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo(pChatItemInfo->strUserID);
	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(pChatItemInfo->strUserID);
	if(pUser == NULL)
	{
		pUser = g_pMessengerActor->GetBuddyInfoFromPersist(pChatItemInfo->strUserID);
	}

	if(pUser != NULL && pData != NULL)
	{
		CString strToolTip;
		pChItem->UpdateUserStatus(pUser->GetStatus());
		//strToolTip.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pUser->GetName(), GetPresenceTip(pChItem->gets), pData->strEmail.c_str());
		pChItem->SetToolTip(strToolTip);
		pChItem->SetUserEmail(pData->strEmail.c_str());
	}

	pChItem->SetTranslateFileInfo(pTranslateFileInfo);
	CChatItem* pChItemLast = NULL;
	int nCntItem = m_pChatModel->GetChatItemCount();

	if (nCntItem > 0)
		pChItemLast = (CChatItem*)m_pChatModel->GetChatItem(nCntItem - 1);

	UIElement* pUIElement = CreateUIElementByChatItem(pChItem);
	if (pUIElement == NULL)
	{
		delete pChItem;
		pChItem = NULL;
		return NULL;
	}

	ITranslateItemCallBack* pTransCallBack = dynamic_cast<ITranslateItemCallBack*>(pUIElement);
	ASSERT(pTransCallBack);
	pTranslateFileInfo->SetTranslateCallback(pTransCallBack);

	m_vcUIElement.push_back(pUIElement);
	m_pChatModel->AddChatItemToArray(pChItem);

	if (m_pChatDlg->IsScrollLocked())
	{
		m_strNewMessageUser = pChItem->GetChatItemInfo()->strUserName;
		m_strRecentMsg = pChItem->GetNewMessage();
		m_pLastChatItem = pChItem;
		m_dwRecentTick = GetTickCount();
		SetTimer(CHATMAIN_TIMER, 1000, NULL);
	}

	l.Unlock();
	m_szTotalViewSize = UpdateElementRect(m_vcUIElement.size() - 1);
	if (!m_pChatDlg->IsScrollLocked())
	{
		ScrollToLastchatItem();
	}
	
	if(bRestore)
	{
		m_rmSqlite.AddFileItemInfo(m_pChatModel->GetRoomID(), pTranslateFileInfo);
	}
	
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);		

	return pUIElement;

}

void CChatMainViewElementList::DrawSelectedText( BOOL bSelection /*= TRUE*/, BOOL bSelectAll /*= FALSE*/ )
{

}

HWND CChatMainViewElementList::GetChatSafeHwnd()
{
	return m_hWnd;
}

BOOL CChatMainViewElementList::DestroyChatWindow()
{
	return DestroyWindow();
}

void CChatMainViewElementList::MoveChatWindow( LPCRECT lpRect, BOOL bRepaint /*= TRUE*/ )
{
	return MoveWindow(lpRect, bRepaint);
}

CWnd* CChatMainViewElementList::GetCWnd()
{
	return this;
}

void CChatMainViewElementList::SetChatDisplayType(int nType)
{
	m_nChatDisplayType = nType;
}

void CChatMainViewElementList::OnSetFocus(CWnd* pWnd)
{
	//::PostMessage(GetChatDlg()->GetSafeHwnd(), UM_CHAT_EDIT_FOCUS, 0, 0);
}

void CChatMainViewElementList::OnKillFocus(CWnd* pWnd)
{
	if(pWnd->GetSafeHwnd() != GetChatDlg()->GetSafeHwnd())
	{
		//::PostMessage(GetChatDlg()->GetSafeHwnd(), UM_CHAT_EDIT_KILLFOCUS, 0, 0);
	}
}

void CChatMainViewElementList::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if ((nChar == 1 || nChar == 33)  && ::GetAsyncKeyState(VK_CONTROL) < 0)
	{
		
	}
	else
	{
		::PostMessage(GetChatDlg()->GetSafeHwnd(), UM_CHAT_EDIT_FOCUS, 0, 0);
		//::PostMessage(GetChatDlg()->GetSafeHwnd(), WM_CHAR, nChar, nRepCnt);
	}
}

int CChatMainViewElementList::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//m_pChatDlg = (CChatDlg*)GetParent();

	int nCX = lpCreateStruct->cx;
	int nCY = lpCreateStruct->cy;

	if (!m_wndScrollBar.Create(WS_CHILD | SBS_VERT, CRect(0, 0, 0, 0), this, ID_CHAT_SCROLLBAR))
		return -1;

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	m_wndScrollBar.SetScrollPos(0);
	m_wndScrollBar.SetScrollRange(0, rcClient.Height());


	for (int i = 0; i < 9; i++)
	{
		CString strFileName;
		strFileName.Format(_T("Chat_my_bubble_%d.png"), i);
		m_pImgMyBubble[i] = new Image(GetImagePath(strFileName));

		strFileName.Format(_T("Chat_other_bubble_%d.png"), i);
		m_pImgOtherBubble[i]  = new Image(GetImagePath(strFileName));
	}

	for(int i = 0; i < 3; i++)
	{
		CString strFileName;
		strFileName.Format(_T("img_chat_talkbg_my_bottom_progressive_%d.png"), i);
		m_pImageBubbleBottomForSendProcess[i] = new Image(GetImagePath(strFileName));
	}

	for(int i = 0; i < 3; i++)
	{
		CString strFileName;
		strFileName.Format(_T("img_chat_talkbg_your_bottom_progressive_%d.png"), i);
		m_pImageBubbleBottomForRecvProcess[i] = new Image(GetImagePath(strFileName));
	}



	for(int i = 0; i < 4; i++)
	{
		CString strFileName;
		strFileName.Format(_T("img_chat_progressive_bar%d.png"), i);
		m_pImgYourProgress[i] = new Image(GetImagePath(strFileName));
	}

	m_pImgRecentMessage = new Image(GetImagePath(_T("img_chat_talk_history_icon.png")));
	m_pImgRecentMessageBK[0] = new Image(GetImagePath(_T("btn_chat_talk_history_nor.png")));
	m_pImgRecentMessageBK[1] = new Image(GetImagePath(_T("btn_chat_talk_history_pre.png")));

	m_pImageDivider = new Image(GetImagePath(_T("btn_chat_talkbg_you_btn_bottom_line.png")));
	m_pImgMyProgress[0] = new Image(GetImagePath(_T("img_chat_progressive_my_bar.png")));
	m_pImgMyProgress[1] = new Image(GetImagePath(_T("img_chat_progressive_my_bg.png")));

	m_pDownloadImage = new Image(GetImagePath(_T("img_chat_talk_down.png")));
	m_pCancelDownloadImage = new Image(GetImagePath(_T("btn_chat_talk_you_down_cancel_nor.png")));
	m_pCancelSendImage = new Image(GetImagePath(_T("img_chat_talk_my_down_cancel_nor.png")));
	m_pDownloadedImage = new Image(GetImagePath(_T("img_chat_talk_files.png")));
	
	m_pImgSendStatus[0] = new Image(GetImagePath(_T("img_chat_noti_l.png")));
	m_pImgSendStatus[1] = new Image(GetImagePath(_T("img_chat_noti_c.png")));
	m_pImgSendStatus[2] = new Image(GetImagePath(_T("img_chat_noti_r.png")));
	m_pImgSendStatus[3] = new Image(GetImagePath(_T("btn_chat_talk_resend.png")));
	m_pImgSendStatus[4] = new Image(GetImagePath(_T("btn_chat_talk_fail.png")));

	m_pImageUserJoin[0] = new Image(GetImagePath(_T("img_chat_talk_date_l_02.png")));
	m_pImageUserJoin[1] = new Image(GetImagePath(_T("img_chat_talk_date_c_02.png")));
	m_pImageUserJoin[2] = new Image(GetImagePath(_T("img_chat_talk_date_r_02.png")));

	m_pImageUserLeave[0] = new Image(GetImagePath(_T("img_chat_talk_date_l_03.png")));
	m_pImageUserLeave[1] = new Image(GetImagePath(_T("img_chat_talk_date_c_03.png")));
	m_pImageUserLeave[2] = new Image(GetImagePath(_T("img_chat_talk_date_r_03.png")));

	m_hWndToolTip = ::CreateWindowEx(0, TOOLTIPS_CLASS, NULL, WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, m_hWnd, NULL, AfxGetInstanceHandle(), NULL);
	::ZeroMemory(&m_ToolInfo, sizeof(m_ToolInfo));

	return 0;
}

void CChatMainViewElementList::OnDestroy()
{
	KillTimer(CHATMAIN_TIMER);
	{
		CSingleLock l(&m_csUIElement, TRUE);
		for (size_t i = 0; i < m_vcUIElement.size(); i++)
		{
			UIElement* pUIElement = m_vcUIElement[i];
			if (pUIElement)
			{
				delete pUIElement;
				pUIElement = NULL;
			}
		}
		m_vcUIElement.clear();
	}

    if (m_hWndToolTip)
    {
        ::DestroyWindow(m_hWndToolTip);
        m_hWndToolTip = NULL;
    }
	//SAFE_DELETE(m_pImgBG);
	for (int i = 0; i < 9; i++)
	{
		SAFE_DELETE(m_pImgMyBubble[i]);
		SAFE_DELETE(m_pImgOtherBubble[i]);
	}

	for(int i = 0; i < 3; i++)
	{
		SAFE_DELETE(m_pImageBubbleBottomForSendProcess[i]);
		SAFE_DELETE(m_pImageBubbleBottomForRecvProcess[i]);
	}

	for (int i = 0; i < 4; i++)
	{
		SAFE_DELETE(m_pImgYourProgress[i]);
	}

	SAFE_DELETE(m_pImgMyProgress[0]);
	SAFE_DELETE(m_pImgMyProgress[1]);
	SAFE_DELETE(m_pDownloadedImage);
	SAFE_DELETE(m_pDownloadImage);
	SAFE_DELETE(m_pCancelDownloadImage);
	SAFE_DELETE(m_pCancelSendImage);
	SAFE_DELETE(m_pImageDivider);
	SAFE_DELETE(m_pImgRecentMessage);
	SAFE_DELETE(m_pImgRecentMessageBK[0]);
	SAFE_DELETE(m_pImgRecentMessageBK[1]);

    for (int i = 0; i < 5; i++)
    {
        SAFE_DELETE(m_pImgSendStatus[i]);
    }
	for(int i = 0; i < 3; i++)
	{
		SAFE_DELETE(m_pImageUserJoin[i]);
		SAFE_DELETE(m_pImageUserLeave[i]);
	}


	CWnd::OnDestroy();
}

BOOL CChatMainViewElementList::OnEraseBkgnd( CDC* pDC )
{
	return TRUE;
}

void CChatMainViewElementList::OnPaint()
{
	//return;
	//TRACE(_T("-----OnPaint-----\n"));
    BOOL bRet = FALSE;
	CPaintDC dc(this);

	//PAINTSTRUCT ps = dc.m_ps;
	//int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	//int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	//int nPX = ps.rcPaint.left;
	//int nPY = ps.rcPaint.top;

	//CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, rt.Width(), rt.Height());
    API_ASSERT(hbmpMem != NULL);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	if (hbmpMem)
	{
        Graphics graph(hdcMemory);

		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		//if (m_pImgBG)
		//{
		//	DrawImageToDest(&graph, m_pImgBG, &rtPS, &rt, &ImgAttr);
		//}
		//else
		{
			SolidBrush brush(m_crChatBG);
			Pen pen(m_crChatBG, 1);
			graph.DrawRectangle(&pen, 0, 0, rt.Width(), rt.Height());
			graph.FillRectangle(&brush, 0, 0, rt.Width(), rt.Height());			
		}

		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetTextRenderingHint(TextRenderingHintClearTypeGridFit);

		
		CPoint ptOffset(0, 0);
		ptOffset.y = m_wndScrollBar.GetScrollPos() * (-1);
		LPChatItemInfo pChatItemInfo = NULL;

		//CalcUIElementRect();
		DrawUIElement(&graph);

		API_VERIFY(BitBlt(dc.GetSafeHdc(), rt.left, rt.top, rt.Width(), rt.Height(), hdcMemory, 0, 0, SRCCOPY));
	}
    if (hbmpMem)
    {
        ::SelectObject(hdcMemory, hbmpOld);
        ::DeleteObject(hbmpMem);  //make sure graph object released
    }
	::DeleteDC(hdcMemory);
}

void CChatMainViewElementList::OnMouseMove( UINT nFlags, CPoint point )
{
	BOOL bRepaint = FALSE;

	// when move mouse, change cursor when mouse in recent message area
	if ((m_rcRecentMsg.PtInRect(point) && !m_strRecentMsg.IsEmpty()) ||
		(IsInRecentMessageButton(point)))
	{
		m_bMouseInRecentMsgRect = true;
		::SetCursor(m_hLinkCursor);
	}
	else if(m_bMouseInRecentMsgRect) // get out of recent message rect
	{
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW)); // when click recent message, set cursor to I arrow
		m_bMouseInRecentMsgRect = false;
	}
	else
	{
		CSingleLock l(&m_csUIElement, TRUE);
		CPoint ptFullClient = point;
		ptFullClient.Offset(GetOffSetPoint());
		for (int i = m_vcUIElement.size() - 1 ; i >= 0; i--)
		{
			if (m_vcUIElement[i]->IsContainPoint(ptFullClient))
			{
				if (m_nStartSelTextIndex != -1 && m_bMouseDown)
				{
					m_nEndSelTextIndex = i;
				}

				if(m_vcUIElement[i]->OnMouseMove(nFlags, ptFullClient))
				{
					bRepaint = TRUE;
					break;
				}
			}
		}

		CRect rcViewer = GetViewRect();
		if ((MK_LBUTTON & nFlags) && m_bMouseSelection && m_wndScrollBar.GetHWND())
		{
			SCROLLINFO stScrollInfo;
			m_wndScrollBar.GetScrollInfo(&stScrollInfo);
			int nPos = m_wndScrollBar.GetScrollPos();
			if (rcViewer.top + 10 >= point.y && nPos > 0)
			{
				nPos -= m_nScrollOneSize;
				nPos = max(0, nPos);

				m_wndScrollBar.SetScrollPos(nPos);
				bRepaint = TRUE;
			}
			else if (rcViewer.bottom - 10 <= point.y && stScrollInfo.nMax - rcViewer.Height() > nPos)
			{
				nPos += m_nScrollOneSize;
                int nTmpPos = stScrollInfo.nMax - rcViewer.Height();
				nPos = min(nTmpPos, nPos);

				m_wndScrollBar.SetScrollPos(nPos);
				bRepaint = TRUE;
			}

		}

		//l.Unlock();
	}


	if (bRepaint)
	{
		UpdateView();
	}

	if (m_bMouseTrack)   
	{
		TRACKMOUSEEVENT csTME;
		csTME.cbSize = sizeof(csTME);
		csTME.dwFlags = TME_LEAVE|TME_HOVER;
		csTME.hwndTrack = m_hWnd;
		csTME.dwHoverTime = m_hWndToolTip == NULL ? 400UL : (DWORD) ::SendMessage(m_hWndToolTip, TTM_GETDELAYTIME, TTDT_INITIAL, 0L);  
		::_TrackMouseEvent(&csTME); 
		m_bMouseTrack = false;   
	}
}	

void CChatMainViewElementList::OnMouseLeave()
{
	{
		CSingleLock l(&m_csUIElement, TRUE);
		for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
		{
			m_vcUIElement[i]->OnMouseLeave();
		}

		//l.Unlock();
	}
	m_bMouseTrack = true;
	CWnd::OnMouseLeave();
}

void CChatMainViewElementList::OnMouseHover( UINT nFlags, CPoint point )
{
	m_bMouseTrack = true;
	CPoint ptFullClient = point;
	ptFullClient.Offset(GetOffSetPoint());
	{
		CSingleLock l(&m_csUIElement, TRUE);
		for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
		{
			m_vcUIElement[i]->OnMouseHover(nFlags, ptFullClient);
		}
	}

	return CWnd::OnMouseHover(nFlags, point);
}

void CChatMainViewElementList::OnLButtonDown( UINT nFlags, CPoint point )
{
	SetFocus();
	if (m_rcRecentMsg.PtInRect(point) && !m_strRecentMsg.IsEmpty())
	{
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW)); // when click recent message, set cursor to I arrow
		
		return CWnd::OnLButtonDown(nFlags, point);
	}
	if(IsInRecentMessageButton(point))
	{
		m_bRecentMessagePress = TRUE;

// 		CRect rc = m_rcRecentMessage[0];//
// 		rc.OffsetRect(-GetOffSetPoint());
		UpdateView();
	}
	m_bMouseSelection = TRUE;
	SetCapture();



	if (m_nStartSelTextIndex != -1 && m_nEndSelTextIndex != -1)
	{
		if (m_nEndSelTextIndex < m_nStartSelTextIndex)
		{
			int c = m_nEndSelTextIndex;
			m_nEndSelTextIndex = m_nStartSelTextIndex;
			m_nStartSelTextIndex = c;
		}

		for (int k = m_nStartSelTextIndex; k <= m_nEndSelTextIndex; k++)
		{
			m_vcUIElement[k]->ResetSelectRange();
		}
	}
	
	m_nStartSelTextIndex = -1;
	m_nEndSelTextIndex = -1;

	CPoint ptFullClient = point;
	ptFullClient.Offset(GetOffSetPoint());
	m_ptSelectionStart = ptFullClient;

	{
		CSingleLock l(&m_csUIElement, TRUE);
		for (int i = m_vcUIElement.size() - 1 ; i >=0; i--)
		{
			if (m_vcUIElement[i]->IsContainPoint(ptFullClient))
			{
				m_nStartSelTextIndex = i;
				m_bMouseDown = TRUE;
				m_vcUIElement[i]->OnLButtonDown(nFlags, ptFullClient);
				break;
			}
		}

		//l.Unlock();
		UpdateView();
	}

	return CWnd::OnLButtonDown(nFlags, point);
}

void CChatMainViewElementList::OnLButtonUp( UINT nFlags, CPoint point )
{
	m_bMouseDown = FALSE;
	BOOL bRecentMessagePress = m_bRecentMessagePress;
	m_bRecentMessagePress = FALSE;
	if (m_rcRecentMsg.PtInRect(point) && !m_strRecentMsg.IsEmpty())
	{
		ScrollToLastchatItem();
		UpdateView();
		m_strRecentMsg = _T("");
		m_pChatDlg->GetChatEdit()->SetFocus();

		return CWnd::OnLButtonUp(nFlags, point);
	}

	ReleaseCapture();

	//when chat dialog is zooming,it's possible that the mouse is just released on the recent message button
	//so we must know whether m_bRecentMessagePress is true,if it's true,it's mean that the mouse has been pressed on the recent message button
	if(bRecentMessagePress && IsInRecentMessageButton(point))
	{
		int nBegin = m_pChatModel->GetChatItemCount();
		if (m_bHaveLastMsg)
		{
			nBegin -= 1;
		}

		int nEnd = nBegin + PAGE_SIZE;

		std::vector<CRecentRecord*> v;
		m_bShowRecentMsg = m_rmSqlite.LoadRecentMessage(m_pChatModel->GetRoomID(),nBegin,nEnd,v);

		CSingleLock l(&m_csUIElement, TRUE);

		UIElement *pElement = NULL;
		CChatItem *pChatItem = NULL;
		if (m_bHaveLastMsg)
		{
			if (m_vcUIElement.size() > 0)
			{
				pElement = m_vcUIElement[0];
				pChatItem = m_pChatModel->GetChatItem(0);

				ASSERT(pElement);
				ASSERT(pChatItem);

				m_pChatModel->RemoveChatItem(0,FALSE);
				m_vcUIElement.erase(m_vcUIElement.begin());
			}
		}

		for (int i = 0; i < (int)v.size(); i++)
		{
			if (m_bHaveLastMsg)
			{
				int nTid = 0;
				CString strUserId;
				if (v[i]->GetType() == CHAT_MSG_FTP)
				{
					TranslateFileInfo *pFileInfo = (TranslateFileInfo *)v[i]->GetData();
					strUserId = pFileInfo->m_strSenderID;
					nTid = pFileInfo->m_TidRequestFileTranslate;
				}
				else
				{
					ChatItemInfo *pcii = (ChatItemInfo *)v[i]->GetData();
					nTid = pcii->nTid;
					strUserId = pcii->strUserID;
				}

				LPChatItemInfo pChatItemInfo = pChatItem->GetChatItemInfo();
				if (pChatItemInfo->nTid == nTid
					&& pChatItemInfo->strUserID.CompareNoCase(strUserId) == 0)
				{
					m_vcUIElement.insert(m_vcUIElement.begin(), pElement);
					m_pChatModel->AddRecentChatItemToArray(pChatItem);
					m_bHaveLastMsg = FALSE;
					continue;
				}
			}

			if (v[i]->GetType() == CHAT_MSG_FTP)
			{
				TranslateFileInfoPtr pTranslateFileInfo((TranslateFileInfo *)v[i]->GetData());
				AddRecentFileMessamge(pTranslateFileInfo);
			}
			else
			{
				AddRecentChatMessamge((ChatItemInfo *)v[i]->GetData());
			}
		}
		
		//l.Unlock();

		ShowScrollBar();
		CalcUIElementRect();
		UpdateScrollInfo();
		
 		if (v.size() > 0)
 		{
 			int nIndex = v.size() - 1;
 			if (m_pChatModel->GetChatItemCount() > v.size())
 			{
 				++nIndex;
 			}
 
 			CChatItem *pLastChatItem = m_pChatModel->GetChatItem(nIndex);
 			ScrollToChatItem(pLastChatItem);
 		}



		
		for (int i = 0; i < v.size(); i++)
		{
			delete v[i];
		}

		v.clear();	

		UpdateView();
		return;
	}

	
	{
		CSingleLock l(&m_csUIElement, TRUE);
		CPoint ptFullClient = point;
		ptFullClient.Offset(GetOffSetPoint());
		for (int i = m_vcUIElement.size() - 1 ; i >=0; i--)
		{
			if (m_vcUIElement[i]->IsContainPoint(ptFullClient))
			{
				m_vcUIElement[i]->OnLButtonUp(nFlags, ptFullClient);
				break;
			}
		}
	}
	//ReleaseCapture();
	m_bMouseSelection = FALSE;
	m_ptSelectionStart.SetPoint(-1, -1);

	return CWnd::OnLButtonUp(nFlags, point);
}

void CChatMainViewElementList::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	/*if(!((nChar == _T('C') || nChar == _T('c'))  && ::GetAsyncKeyState(VK_CONTROL) < 0)
		&& (nFlags & MK_CONTROL))
		)
	{
		ASSERT(FALSE);
	}*/
	if ((nChar == _T('C') || nChar == _T('c'))  && ::GetKeyState(VK_CONTROL) < 0)
	{
		CopyTextToClipboard();
		return;
	}
	if ((nChar == _T('V') || nChar == _T('v'))  && ::GetKeyState(VK_CONTROL) < 0)
	{
		//::PostMessage(GetChatDlg()->GetSafeHwnd(), UM_CHAT_EDIT_FOCUS, 0, 0);
		//::PostMessage(GetChatDlg()->GetSafeHwnd(), WM_KEYDOWN, 0, 0);
		return;
	}
	if (nChar == VK_ESCAPE && m_pChatDlg != NULL)
	{
		::PostMessage(m_pChatDlg->GetHWND(), WM_KEYDOWN, VK_ESCAPE, 0);
		return; 
	}
	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChatMainViewElementList::OnSize( UINT nType, int cx, int cy )
{
	CWnd::OnSize(nType, cx, cy);
	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);

	int nSX = 0, nSY = 0, nEX = 0, nEY = 0, nCX = 0, nCY = 0;
	int nImgWidth = 0, nImgHeight = 0;

	if (m_wndScrollBar.GetHWND())
	{
		nCX = GetSystemMetrics(SM_CXVSCROLL);
		nSX = rtClient.right - nCX;
		nSY = rtClient.top;
		nCY = rtClient.Height();	

		CRect rcScrollBar(0, 0, 0, 0);
		rcScrollBar.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		m_wndScrollBar.MoveWindow(&rcScrollBar);

		ShowScrollBar();
		CalcUIElementRect();
		UpdateScrollInfo();
		
		::InvalidateRect(m_hWnd,NULL,FALSE);
	}

	CWnd::OnSize(nType, cx, cy);
}

LRESULT CChatMainViewElementList::OnVscrollView( WPARAM wParam, LPARAM lParam )
{
	CScrollBarEx *pScrollBar = (CScrollBarEx*)lParam;
	if (pScrollBar)
	{
		int nCurPos = wParam;

		//CSize sz = CalcUIElementRect();
		CSize sz = m_szTotalViewSize;
		CRect rcClient(0, 0, 0, 0);
		GetClientRect(&rcClient);
        int nTmpPos = sz.cy - rcClient.Height();
		nCurPos = min(nCurPos, nTmpPos);
		if (nCurPos < 0)
		{
			nCurPos = 0;
		}

		pScrollBar->SetScrollPos(nCurPos);

		_SetScrollLock(nCurPos, sz.cy);

		//CalcUIElementRect();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);		
	}

	return 0;
}
LRESULT CChatMainViewElementList::OnUmSplitterMove( WPARAM wParam, LPARAM lParam )
{
	int nMove = (int)lParam;
	if (nMove == 0)
		return 0;

	CRect rtWnd(0, 0, 0, 0);
	GetWindowRect(&rtWnd);

	rtWnd.DeflateRect(0, nMove, 0, 0);
	if (rtWnd.Height() <= DEF_CHAT_MAIN_MIN_HEIGHT)
		return 0;
	//m_pChatDlg->ScreenToClient(&rtWnd);
	m_nSplitterMove = nMove;
	MoveWindow(&rtWnd);
	m_nSplitterMove = 0;
	return 1;
}

BOOL CChatMainViewElementList::OnSetCursor( CWnd* pWnd, UINT nHitTest, UINT message )
{
	switch (m_nCursor)
	{
	case CURSOR_HAND:
		{
			::SetCursor(m_hLinkCursor);
			return TRUE;
		}
	case CURSOR_IBEAM:
		{
			::SetCursor(m_hIbeamCursor);
			return TRUE;
		}
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CChatMainViewElementList::OnLButtonDblClk( UINT nFlags, CPoint point )
{
	SetFocus();

	{
		CSingleLock l(&m_csUIElement, TRUE);
		CPoint ptFullClient = point;
		ptFullClient.Offset(GetOffSetPoint());
		//for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
		for (int i = m_vcUIElement.size() - 1; i >=0; i--)
		{
			if(m_vcUIElement[i]->IsContainPoint(ptFullClient))
			{
				m_nStartSelTextIndex = m_nEndSelTextIndex = i;
				m_vcUIElement[i]->OnLButtonDblClk(nFlags, ptFullClient);
			}
			
		}

		//l.Unlock();
	}
	
	UpdateView();

	return CWnd::OnLButtonDblClk(nFlags, point);
}

void CChatMainViewElementList::OnRButtonUp( UINT nFlags, CPoint point )
{
	m_nCursor = CURSOR_DEFAULT;

	CPoint pt(0, 0);
	GetCursorPos(&pt);

	CMenu menuList;
	menuList.LoadMenu(IDR_MENU_CHAT);

	CMenu* popupMenu = menuList.GetSubMenu(1);

	if (!IsSelectedItemExists())
		popupMenu->EnableMenuItem(ID_CHAT_MAIN_COPY , MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

	popupMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);

	{
		CSingleLock l(&m_csUIElement, TRUE);
		CPoint ptFullClient = point;
		ptFullClient.Offset(GetOffSetPoint());
		for (int i = m_vcUIElement.size() - 1; i >=0; i--)
		{
			m_vcUIElement[i]->OnRButtonUp(nFlags, ptFullClient);
		}
		//l.Unlock();
	}

	return CWnd::OnRButtonUp(nFlags, point);
}

BOOL CChatMainViewElementList::IsSelectedItemExists()
{
	//CSingleLock l(&m_csUIElement, TRUE);
	CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
	int nChatItemCount = m_pChatModel->GetChatItemCount();
	for (int i = 0 ; i < nChatItemCount; i++)
	{
		CChatItem* pChatItem = m_pChatModel->GetChatItem(i);
		if (!pChatItem)
		{
			continue;
		}
		if (!pChatItem->GetSelectedText().IsEmpty())
		{
			return TRUE;
		}
	}
	return FALSE;
}

void CChatMainViewElementList::OnMenuMainCopy()
{
	CopyTextToClipboard();
}
CString CChatMainViewElementList::GetPlainSelectedText()
{

	CString strSelected = _T("");
	CChatItem* pChItem = NULL;
	int nCount = m_pChatModel->GetChatItemCount();

	BOOL bSelectStart = FALSE;

	for (int i = 0; i < nCount; i++)
	{
		pChItem = (CChatItem*)m_pChatModel->GetChatItem(i);

		UIElement* pUIElement = NULL; 
		for (size_t j = 0; j < m_vcUIElement.size(); j++)
		{
			if (m_vcUIElement[j]->IsSameChatItem(pChItem))
			{
				pUIElement = m_vcUIElement[j];
				break;
			}
		}

		if (!pChItem || !pUIElement)
			continue;

		CString strItemSelectText = pChItem->GetSelectedText();
		CString strTimeSelectText = pChItem->GetTimeSelectedText(pUIElement->GetTimeString());
		CString strNameSelectText = pChItem->GetNameSelectedText();
		if (!strItemSelectText.IsEmpty() || !strTimeSelectText.IsEmpty() ||
			!strNameSelectText.IsEmpty())
		{
			if (bSelectStart)
				strSelected.Append(_T("\r\n"));
			else
				bSelectStart = TRUE;


			LPChatItemInfo pChatItemInfo = pChItem->GetChatItemInfo();
			if (pChatItemInfo && (pChatItemInfo->eMsgGB == CHAT_MSG_CHAT || pChatItemInfo->eMsgGB == CHAT_MSG_STICKER) ||
				pChatItemInfo->eMsgGB == CHAT_MSG_FTP)
			{
				//if(strNameSelectText.IsEmpty())
				//{
				//	strSelected.AppendFormat(TEXT("%s  \t"),
				//	strTimeSelectText);
				//}
				//else
				//{
				//	strSelected.AppendFormat(TEXT("%s\r\n%s  \t"),
				//	strNameSelectText, strTimeSelectText);
				//}
				if (!strNameSelectText.IsEmpty())
				{
					strSelected.AppendFormat(TEXT("%s\r\n"), strNameSelectText);
				}

				if (!strTimeSelectText.IsEmpty())
				{
					strSelected.AppendFormat(TEXT("%s \t"), strTimeSelectText);
				}
			}
			strSelected.Append(strItemSelectText);
		}
	}

	return strSelected;
}

CString CChatMainViewElementList::GetSelectedText()
{
	CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
	CSingleLock l(&m_csUIElement, TRUE);
	
	CString strSelected = _T("");
	CChatItem* pChItem = NULL;
	int nCount = m_pChatModel->GetChatItemCount();

	BOOL bSelectStart = FALSE;

	int nCopyNameDate = GET_CONFIG()->GetCopyNameDate();
	if (m_nChatDisplayType == CHAT_PLAIN)
	{
	   return GetPlainSelectedText();
	}

	for (int i = 0; i < nCount; i++)
	{
		pChItem = (CChatItem*)m_pChatModel->GetChatItem(i);

		UIElement* pUIElement = NULL; 
		for (size_t j = 0; j < m_vcUIElement.size(); j++)
		{
			if (m_vcUIElement[j]->IsSameChatItem(pChItem))
			{
				pUIElement = m_vcUIElement[j];
				break;
			}
		}

		if (!pChItem || !pUIElement)
			continue;

		CString strItemSelectText = pChItem->GetSelectedText();
		if (!strItemSelectText.IsEmpty())
		{
			if (bSelectStart)
				strSelected.Append(_T("\r\n"));
			else
				bSelectStart = TRUE;

			if (nCopyNameDate == 1)
			{
				LPChatItemInfo pChatItemInfo = pChItem->GetChatItemInfo();
				if (pChatItemInfo && (pChatItemInfo->eMsgGB == CHAT_MSG_CHAT || pChatItemInfo->eMsgGB == CHAT_MSG_STICKER))
				{
					strSelected.AppendFormat(TEXT("%s\t%s %s \r\n"),
						pChatItemInfo->strUserName, pUIElement->GetDateString(), pUIElement->GetTimeString());
				}
			}
			strSelected.Append(strItemSelectText);
		}
	}

	return strSelected;
}

void CChatMainViewElementList::CopyTextToClipboard()
{
	WCHAR *lpwstrCopy = NULL;
	HGLOBAL hglbCopy = NULL; 
	CString strSelText = GetSelectedText();
	
	OutputDebugString(_T("--------strSelText--------\n"));
	OutputDebugString(strSelText);
	OutputDebugString(_T("\n---------End--------\n"));
	if (strSelText.IsEmpty())
	{
		return;
	}

	const int dwUnicodeLen = strSelText.GetLength();

	if (FALSE == OpenClipboard())
	{
		return;
	}

	EmptyClipboard(); 

	// 1. Unicode Text 
	hglbCopy = GlobalAlloc(GHND, (dwUnicodeLen + 1) * sizeof(WCHAR)); 

	if (hglbCopy == NULL) 
	{
		CloseClipboard();
		return;
	}

	lpwstrCopy = (WCHAR*)GlobalLock(hglbCopy);

	if (NULL != lpwstrCopy)
	{
		wcscpy_s(lpwstrCopy, dwUnicodeLen + 1, strSelText.GetBuffer());
		GlobalUnlock(hglbCopy); 

		SetClipboardData(CF_UNICODETEXT, hglbCopy); 
	}

	// 2. Ansi Text 
	char *lpstrCopy = NULL;

	const int dwLen = WideCharToMultiByte(CP_ACP, 0, strSelText, -1, NULL, 0, NULL, NULL);
	char *lpData = new char[dwLen];

	if (NULL == lpData)
	{
		return;
	}

	memset(lpData, 0, dwLen);
	WideCharToMultiByte(CP_ACP, 0, strSelText, -1, lpData, dwLen, 0, 0); 

	hglbCopy = GlobalAlloc(GHND, dwLen + 1); 

	if (hglbCopy == NULL) 
	{
		CloseClipboard();
		delete[] lpData;
		return;
	}

	lpstrCopy = (char *)GlobalLock(hglbCopy); 

	if (NULL != lpstrCopy)
	{
		strncpy_s(lpstrCopy, dwLen + 1, lpData, dwLen);
		GlobalUnlock(hglbCopy); 
		SetClipboardData(CF_TEXT, hglbCopy); 
	}

	delete[] lpData;

	CloseClipboard(); 
}

BOOL CChatMainViewElementList::PreTranslateMessage( MSG* pMsg )
{
	

	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message == WM_RBUTTONDOWN || pMsg->message == WM_MBUTTONDOWN)
	{
		::PostMessage(m_pChatDlg->GetHWND(), MSG_CLICK_MAIN_VIEW, 0, 0);
	}
	if (pMsg->message == WM_COPY)
	{
		CopyTextToClipboard();
		return TRUE;
	}
	else if (GetKeyState(VK_CONTROL) < 0 && 
		(_T('a') == (TCHAR)pMsg->wParam || _T('A') == (TCHAR)pMsg->wParam))
	{
		m_bMouseSelection = TRUE;
		SelectAllItem(TRUE);
	}
	else if (pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4)
	{
		m_pChatDlg->CheckCloseChatDialog();
		return TRUE;
	}
	return CWnd::PreTranslateMessage(pMsg);
}

BOOL CChatMainViewElementList::CreateElementList( LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, int nDisplayType)
{
	m_nChatDisplayType = nDisplayType;
	return Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID);
}

UIElement* CChatMainViewElementList::CreateUIElementByChatItem( CChatItem* pChatItem )
{
	UIElement *pElement = NULL;
	if (pChatItem)
	{
		ECHAT_MSG_TYPE emMsgType = pChatItem->GetItemType();

		switch (emMsgType)
		{
		case CHAT_MSG_RECOVER_SESSION:
		case CHAT_MSG_SYS:
			{
				pElement = new UISysMsgElement(pChatItem, this);
				break;
			}
		case CHAT_MSG_STICKER:
			{
				pElement = new UIStickerElement(pChatItem, this);
				break;
			}
		case CHAT_MSG_FTP:
			{
				pElement = new UIChatFileElement(pChatItem, this);
				break;
			}
		case CHAT_MSG_CHAT:
			{
				pElement = new UIChatElement(pChatItem, this);
				break;
			}
		case CHAT_MSG_JOIN:
		case CHAT_MSG_LEAVE:
			{
				pElement = new UIUserJoinElement(pChatItem, this);
				break;
			}
		}
	}

	if (pElement)
	{
		pElement->SetChatMainView(this);
	}
	return pElement;
}

Image* CChatMainViewElementList::GetSysMsgBGImage()
{
	return m_pImgSysMsgBG;
}

Image* CChatMainViewElementList::GetSysMsgArrowImage()
{
	return m_pImgSysMsgArrow;
}

Image* CChatMainViewElementList::GetImgDateBGImage(int nIndex)
{
	if(nIndex < 0 || nIndex >= 3)
	{
		return NULL;
	}

	return m_pImgDateBG[nIndex];
}

Image* CChatMainViewElementList::GetStickerImageByID( LPCTSTR strID )
{
	CString strStickerID = strID;
	return GetStickerImage(strStickerID);
}

CWnd* CChatMainViewElementList::GetCurrentWnd()
{
	return GetCWnd();
}

void CChatMainViewElementList::UpdateScrollInfo()
{
	if (IsWindow(m_hWnd) && m_wndScrollBar.IsWindowEnabled())
	{
		CSize sz = m_szTotalViewSize;//CalcUIElementRect();
		CRect rcClient(0, 0, 0, 0);
		GetClientRect(&rcClient);
		SCROLLINFO si;
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask = SIF_ALL;
		if (sz.cy > rcClient.Height())
		{
			m_wndScrollBar.ShowScrollBar(TRUE);
			si.nMin = 0;
			si.nMax = sz.cy;
			si.nPage = rcClient.Height();
			si.nPos = m_wndScrollBar.GetScrollPos();
			si.nTrackPos = si.nPos;
		}
		else
		{	
			m_wndScrollBar.ShowScrollBar(FALSE);
			si.nMin = 0;
			si.nMax = rcClient.Height();
			si.nPage = rcClient.Height();
			si.nPos = 0;
			si.nTrackPos = si.nPos;
		}
		//CalcUIElementRect();
		m_wndScrollBar.SetScrollInfo(&si);
	}
} 


CSize CChatMainViewElementList::CalcRecentMessageButton()
{
//	m_bShowRecentMsg = FALSE;

	for(int i = 0; i < 3; i++)
	{
		m_rcRecentMessage[i].SetRectEmpty();
	}

	CSize szText(0, 0);
	CRect rtText(0, 0, 500, 500);
	REAL fontHeight = RECTENT_MESSAGE_FONT_HEIGHT;
	CRect rcView = GetViewRect();
	if (m_pChatModel)
	{
		int nRoomId = m_pChatModel->GetRoomID();
		if (nRoomId != 0)
		{
//			m_bShowRecentMsg = m_rmSqlite.IsExistRecentMessage(nRoomId,m_vcUIElement.size());
			if (!m_bShowRecentMsg)
			{
				return CSize(0,0);
			}
		}
	}


	CString str = LoadStringFromResource(IDS_STRING_RECENT_MESSAGE);
	RecalcTextRect(GetCurrentWnd(), str, 
		g_defaultFontFaceName, fontHeight, FontStyleRegular, rtText, szText);

	const int nPAD = 5;
	int nTextWidth = szText.cx;
	int nWidth = nTextWidth + nPAD + GetRecentMessageImage()->GetWidth();

	//0:bk
	//1:icon
	//2:text

	m_rcRecentMessage[0] = rcView;
	m_rcRecentMessage[0].bottom = m_rcRecentMessage[0].top + 
		GetRecentMessageBKImage(TRUE)->GetHeight();

	m_rcRecentMessage[1].left += (m_rcRecentMessage[0].Width() - nWidth) / 2; 
	m_rcRecentMessage[1].right = m_rcRecentMessage[1].left + GetRecentMessageImage()->GetWidth();
	m_rcRecentMessage[1].top += (GetRecentMessageBKImage(TRUE)->GetHeight() - GetRecentMessageImage()->GetHeight()) / 2;
	m_rcRecentMessage[1].bottom = m_rcRecentMessage[1].top + GetRecentMessageImage()->GetHeight();

	m_rcRecentMessage[2] = m_rcRecentMessage[0];
	m_rcRecentMessage[2].left = m_rcRecentMessage[1].right + nPAD;
	m_rcRecentMessage[2].right = m_rcRecentMessage[2].left + nTextWidth;
 	m_rcRecentMessage[2].top = ((m_rcRecentMessage[2].bottom + m_rcRecentMessage[2].top) - szText.cy)/2 + 2;
 	m_rcRecentMessage[2].bottom = m_rcRecentMessage[2].top + szText.cy;



	//m_rcRecentMessageBottom.SetRect(rcView, 0, rcView.right, szName.cy + nPad);
 	CSize size =  CSize(m_rcRecentMessage[0].left, m_rcRecentMessage[0].bottom );
// 	for(int i = 0; i < 3; i++)
// 	{
// 		m_rcRecentMessage[i].OffsetRect(-GetOffSetPoint());
// 	}

	return size;
}

void   CChatMainViewElementList::UpdateView()
{
	::InvalidateRect(m_hWnd,NULL,FALSE);
	//RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

DWORD CChatMainViewElementList::CalcItemFlag(int iIndex)
{
	DWORD dwFlags = 0;

	if (iIndex >= 0 && iIndex <= m_vcUIElement.size())
	{
		CChatItem *pChatItem = m_vcUIElement[iIndex]->GetChatItem();
		LPChatItemInfo pCurInfo = pChatItem->GetChatItemInfo();
		if (iIndex == 0 || IsDrawDate(m_vcUIElement[iIndex - 1]->GetChatItemInfo()->time,pCurInfo->time))
		{
			dwFlags |= DEF_CHAT_MSG_DATE;
		}

		if (pCurInfo->strUserID.CompareNoCase(m_pChatModel->GetMyID()) == 0)
		{
			dwFlags |= DEF_CHAT_MSG_ISMINE;

			int nMsgType = pChatItem->GetItemType();
			int nMsgStatus = pChatItem->GetMsgStatus();

			BOOL bMsgResult = FALSE;
			BOOL bSuccessful = FALSE;
			if (nMsgType == CHAT_MSG_FTP || nMsgType == CHAT_MSG_CHAT || nMsgType == CHAT_MSG_STICKER) 
			{
				if (nMsgType == CHAT_MSG_FTP)
				{
					switch (nMsgStatus)
					{
					case sUploadCancle:
					case sUploadError:
						{
							bMsgResult = TRUE;
							bSuccessful = FALSE;
							break;
						}
					case sUploadSuccess:
						{
							bMsgResult = TRUE;
							bSuccessful = TRUE;
							break;
						}
					case sUploadWaiting:
					case sUploading:
						{
							break;
						}
					}
				}
				else/* if (nMsgType == CHAT_MSG_CHAT || nMsgType == CHAT_MSG_STICKER)*/
				{
					if (nMsgStatus != CMS_INVALID)
					{
						bMsgResult = TRUE;
						bSuccessful = (nMsgStatus == CMS_SUCCEED)?TRUE:FALSE;
					}
				}
			}

			if (bMsgResult)
			{
				if (!bSuccessful)
				{
					dwFlags |= DEF_CHAT_MSG_RESEND;
				} 
				else
				{
					if (iIndex == 0
						|| m_tMyLastTime == 0
						|| IsDrawTime(pCurInfo->time, m_tMyLastTime) 
						|| m_vcUIElement[iIndex - 1]->GetChatItemInfo()->strUserID.Compare(m_pChatModel->GetMyID()) != 0
						|| (dwFlags & DEF_CHAT_MSG_DATE))
					{
						m_tMyLastTime = pCurInfo->time; 
						dwFlags |= DEF_CHAT_MSG_TIME;
					}   
				}
			}
		}
		else
		{

			if (iIndex == 0)
			{
				m_tBuddyLastTime = pCurInfo->time;
				dwFlags |= DEF_CHAT_MSG_TIME|DEF_CHAT_MSG_USERNAME;
			}  
			else
			{
				if (m_vcUIElement[iIndex - 1]->GetChatItemInfo()->strUserID.Compare(pCurInfo->strUserID) != 0)
				{
					dwFlags |= DEF_CHAT_MSG_TIME|DEF_CHAT_MSG_USERNAME;
					m_tBuddyLastTime = pCurInfo->time;
				}
				else if (IsDrawTime(pCurInfo->time, m_tBuddyLastTime))
				{
					dwFlags |= DEF_CHAT_MSG_TIME;
					m_tBuddyLastTime = pCurInfo->time;  
				}
			}
		}
	}
	return dwFlags;
}

CSize CChatMainViewElementList::CalcUIElementRect()
{
	CSize szTotal(0, 0);
	CPoint ptOffset(0, 0);
	CString strCurUserID = m_pChatModel->GetMyID();
	CSingleLock l(&m_csUIElement, FALSE);
	l.Lock();

	m_tBuddyLastTime = 0;
	m_tMyLastTime = 0;

	CSize sz(0, 0); 
	sz = CalcRecentMessageButton();
	ptOffset.y += sz.cy;
	szTotal += sz;
	for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
	{ 
		DWORD dwFlags = CalcItemFlag(i);
		sz = m_vcUIElement[i]->CalcSize(ptOffset, dwFlags);
		szTotal += sz;
		ptOffset.y += sz.cy;
	}

	szTotal.cy += CHAT_ELEMENTLIST_BOTTOM;

	m_szTotalViewSize = szTotal;
	//l.Unlock();

	
	return szTotal;
}

BOOL CChatMainViewElementList::ShowScrollBar()
{
	BOOL bResult = FALSE;
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	CSize szTotal(0, 0);
	CPoint ptOffset(0, 0);
	CSingleLock l(&m_csUIElement, FALSE);
	l.Lock();

	CSize sz(0, 0); 
	sz = CalcRecentMessageButton();
	ptOffset.y += sz.cy;
	szTotal += sz;
	for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
	{ 
		DWORD dwFlags = CalcItemFlag(i);
		sz = m_vcUIElement[i]->CalcSize(ptOffset, dwFlags);
		szTotal += sz;
		ptOffset.y += sz.cy;

		if (szTotal.cy > rcClient.Height())
		{
			bResult = TRUE;
			break;
		}		
	}

	szTotal.cy += CHAT_ELEMENTLIST_BOTTOM;
	if (szTotal.cy > rcClient.Height())
	{
		bResult = TRUE;
	}		

	//l.Unlock();

	m_wndScrollBar.ShowScrollBar(bResult);
	return bResult;
}
void CChatMainViewElementList::ScrollToLastchatItem()
{
	CSize sz = m_szTotalViewSize;//CalcUIElementRect();
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	if (sz.cy > rcClient.Height())
	{
		si.nMin = 0;
		si.nMax = sz.cy;
		si.nPage = rcClient.Height();
		si.nPos = sz.cy - rcClient.Height();
		si.nTrackPos = si.nPos;
		_SetScrollLock(si.nPos, sz.cy);
	}
	else
	{
		si.nMin = 0;
		si.nMax = rcClient.Height();;
		si.nPage = rcClient.Height();
		si.nPos = 0;
		si.nTrackPos = 0;
	}

	m_wndScrollBar.SetScrollInfo(&si);
}

void CChatMainViewElementList::ScrollToChatItem( CChatItem* pChItem )
{
	CSingleLock l(&m_csUIElement, FALSE);
	l.Lock();

	int nPos = 0;
	int nTotalHeight = m_rcRecentMessage[0].Height() + CHAT_ELEMENTLIST_TOP;
	for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
	{
		CRect rc = m_vcUIElement[i]->GetElementRect();

		if (m_vcUIElement[i]->IsSameChatItem(pChItem))
		{
			nPos = nTotalHeight;
		}

		nTotalHeight += rc.Height();
	}

	//l.Unlock();

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	if (nTotalHeight > rcClient.Height())
	{
		si.nMin = 0;
		si.nMax = nTotalHeight;
		si.nPage = rcClient.Height();
		si.nPos = nPos - rcClient.Height();
		if (si.nPos < 0)
		{
			si.nPos = 0;
		}

		si.nTrackPos = si.nPos;
		_SetScrollLock(si.nPos,nTotalHeight);
	}
	else
	{
		si.nMin = 0;
		si.nMax = rcClient.Height();
		si.nPage = rcClient.Height();
		si.nPos = 0;
		si.nTrackPos = 0;
	}
	m_wndScrollBar.SetScrollInfo(&si);
}

CPoint CChatMainViewElementList::GetOffSetPoint()
{
	CPoint pt(0, 0);
	if (m_wndScrollBar.GetHWND())
	{
		pt.y = m_wndScrollBar.GetScrollPos();
	}
	return pt;
}


bool CChatMainViewElementList::IsInRecentMessageButton(CPoint pt)
{
	if (!m_bShowRecentMsg || m_rcRecentMessage[0].IsRectEmpty())
	{
		return false;
	}

	CRect rc = m_rcRecentMessage[0];
	rc.OffsetRect(-GetOffSetPoint());
	if(rc.PtInRect(pt))
	{
		return true;
	}

	return false;
}

void CChatMainViewElementList::DrawRecentMessageButton(Graphics* pGaphics)
{
	CPoint ptOffset = -GetOffSetPoint();

	CRect rcClient = GetViewRect();
	CRect rcRecentMessage[3];
	
	for(int i = 0; i < 3; i++)
	{
		rcRecentMessage[i] = m_rcRecentMessage[i];
		::OffsetRect(&rcRecentMessage[i],ptOffset.x,ptOffset.y);
	}
	
	//RectF rcView(rcClient.left,rcClient.top,rcClient.right,rcClient.bottom);
	RECT rc = {0};
	if (!IntersectRect(&rc,&rcClient,rcRecentMessage[0]))
	{
		return;
	}
    //If want log, use this    
    //TRACE(_T("DrawRecentMessageButton, rcRecentMessage={%f,%f -- %f x %f}\n"), rcRecentMessage[0].X,
    //    rcRecentMessage[0].Y, rcRecentMessage[0].Width, rcRecentMessage[0].Height);

	Image* pImageBK = GetRecentMessageBKImage(!m_bRecentMessagePress); 
	Image* pImageIcon = GetRecentMessageImage();
	if(pImageBK != NULL && pImageIcon!= NULL)
	{
		ImageAttributes ImgAttr;
		InterpolationMode interpolationMode = pGaphics->GetInterpolationMode();
		PixelOffsetMode pixelOffsetMode = pGaphics->GetPixelOffsetMode();
		pGaphics->SetInterpolationMode(InterpolationModeBilinear);
		pGaphics->SetPixelOffsetMode(PixelOffsetModeHalf);

		//draw bk
		
		DrawImageToDest(pGaphics, pImageBK, &rcClient, &rcRecentMessage[0], &ImgAttr);

		//draw icon
		DrawImageToDest(pGaphics, pImageIcon, &rcClient, &rcRecentMessage[1], &ImgAttr);

		pGaphics->SetInterpolationMode(interpolationMode);
		pGaphics->SetPixelOffsetMode(pixelOffsetMode);
	}
	
	StringFormat format;
	format.SetAlignment(StringAlignmentCenter);
	format.SetLineAlignment(StringAlignmentCenter);


	Color clDRM(CColorConvert::HEX2Color(0x000000));
	SolidBrush brush(clDRM);

	CString str = LoadStringFromResource(IDS_STRING_RECENT_MESSAGE);
	REAL fontHeight = RECTENT_MESSAGE_FONT_HEIGHT;
	Gdiplus::Font font(g_defaultFontFaceName, fontHeight, FontStyleRegular);
	
	RectF rcText(rcRecentMessage[2].left,rcRecentMessage[2].top,rcRecentMessage[2].Width(),rcRecentMessage[2].Height());
 	pGaphics->DrawString(str, str.GetLength(), &font, rcText, &format, &brush);
}

void CChatMainViewElementList::DrawUIElement(Graphics* graph)	
{
	CSingleLock l(&m_csUIElement, TRUE);

	
	//if(m_vcUIElement.size() > 0)
	if (m_bShowRecentMsg)
	{
		DrawRecentMessageButton(graph);
	}

	CRect rcDest(0, 0, 0, 0);
	CRect rcView(0, 0, 0, 0);
	GetClientRect(&rcView);
	for (size_t i = 0 ; i < m_vcUIElement.size(); i++)
	{
		CRect rcElement = m_vcUIElement[i]->GetElementRect();	
		rcElement.OffsetRect(-GetOffSetPoint());
		if (rcDest.IntersectRect(&rcView,&rcElement))
		{
			m_vcUIElement[i]->Draw(graph);
		}
		//
	}

	if (m_pChatDlg->IsScrollLocked() && !m_strRecentMsg.IsEmpty())
	{

		Image* pbg = CFTImageMapInt::Instance()->GetImageByID(img_talk_newmessages_bg);
		if (pbg)
		{
			m_rcRecentMsg = GetViewRect();
			m_rcRecentMsg.top = m_rcRecentMsg.bottom - pbg->GetHeight();

			// when floating recent message, change cursor if necessary
			RECT rcWindow = {0};
			GetWindowRect(&rcWindow);
			POINT ptCursor = {0, 0};
			if(TRUE == GetCursorPos(&ptCursor))
			{
				ptCursor.x -= rcWindow.left;
				ptCursor.y -= rcWindow.top;
				if (m_rcRecentMsg.PtInRect(ptCursor))
				{
					::SetCursor(m_hLinkCursor); 
					m_bMouseInRecentMsgRect = true;
				}
			};

			graph->DrawImage(pbg, m_rcRecentMsg.left, m_rcRecentMsg.top, m_rcRecentMsg.Width(), m_rcRecentMsg.Height());


			CRect rcUserImage(7, 5, 28, 26);
            CString strUserId = m_pLastChatItem->GetChatItemInfo()->strUserID;
            CString strUserImagePath = GET_APP()->GetProfileImagePath(strUserId);

            Image userImage(strUserImagePath);
			rcUserImage.OffsetRect(m_rcRecentMsg.TopLeft());
			graph->DrawImage(&userImage, rcUserImage.left, rcUserImage.top, rcUserImage.Width(), rcUserImage.Height());

			Image* pBtn = CFTImageMapInt::Instance()->GetImageByID(img_talk_newmessages_btn);
			CRect rcBtn( m_rcRecentMsg.right - 27, m_rcRecentMsg.top + 5, m_rcRecentMsg.right - 6, m_rcRecentMsg.top + 26);
			graph->DrawImage(pBtn, rcBtn.left, rcBtn.top, rcBtn.Width(), rcBtn.Height());


			//HDC hDC = graph->GetHDC();
			REAL fFontHeight = 9.0f;//(REAL)(11.0f * 72 / ::GetDeviceCaps(hDC, LOGPIXELSY));
			//graph->ReleaseHDC(hDC);
			Gdiplus::Font nameFont(g_defaultFontFaceName, fFontHeight, FontStyleRegular);
			Gdiplus::Font msgFont(g_defaultFontFaceName, fFontHeight, FontStyleRegular);
			StringFormat format;
			format.SetAlignment(StringAlignmentNear);
			REAL fLeft = CHATMAIN_USERNAME_LEFT;

			REAL fY = m_rcRecentMsg.top + (m_rcRecentMsg.Height() - nameFont.GetHeight(graph))/ 2;
			Color clName(CColorConvert::HEX2Color(0x2d95ff));
			SolidBrush namebrush(clName);
			RectF rcName(fLeft, fY, 500, nameFont.GetHeight(graph));
			CRect rtBound(fLeft, fY, fLeft + 500, fY + nameFont.GetHeight(graph));
			
			CSize szSize(0, 0);
			RecalcTextRectVert(this, m_strNewMessageUser, g_defaultFontFaceName, fFontHeight, FontStyleRegular, rtBound, szSize);
			rcName.Width = szSize.cx;
			rcName.Height = szSize.cy;

			
			graph->DrawString(m_strNewMessageUser, m_strNewMessageUser.GetLength(), &nameFont, rcName, &format, &namebrush);
			fLeft += rcName.Width;
			fLeft += CHATMAIN_MSG_LEFT;
	
			CRect rcTmp = m_rcRecentMsg;
			rcTmp.left = fLeft;
			rcTmp.right = m_rcRecentMsg.right - 33;
			CString str = RecalcTextString(this, m_strRecentMsg, g_defaultFontFaceName, fFontHeight, FontStyleRegular, rcTmp);

			RectF layoutRect;
			layoutRect.X = rcTmp.left;
			layoutRect.Width = rcTmp.Width();
			layoutRect.Y = fY;
			layoutRect.Height = msgFont.GetHeight(graph);

			Color clMsg(59, 59, 59);
			SolidBrush msgbrush(clMsg);
			graph->MeasureString(str, -1, &msgFont, PointF(layoutRect.X, layoutRect.Y), &layoutRect);
			layoutRect.Width += 1;
			layoutRect.Height += 1;
			graph->DrawString(str, str.GetLength(), &msgFont, layoutRect, &format, &msgbrush);

			
		}
	}

	//l.Unlock();
}

BOOL CChatMainViewElementList::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	if (m_wndScrollBar.GetHWND())
	{
		CRect rcClient(0, 0, 0, 0);
		GetClientRect(&rcClient);

		SCROLLINFO stScrollInfo;
		m_wndScrollBar.GetScrollInfo(&stScrollInfo);
		if (stScrollInfo.nMax > rcClient.Height())
		{
			int nPos = m_wndScrollBar.GetScrollPos();
			nPos -= m_nScrollOneSize * zDelta / WHEEL_DELTA;
            int nTmpPos = stScrollInfo.nMax - rcClient.Height();
			nPos = min(nTmpPos, nPos);
			nPos = max(0, nPos);
			m_wndScrollBar.SetScrollPos(nPos);

			_SetScrollLock(nPos, stScrollInfo.nMax);
			
		}


		//CalcUIElementRect();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	}
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}


Image* CChatMainViewElementList::GetFileTransferImageByID(UINT ResID)
{
	//return CFTImageMap::GetImage(ResID);
	return CFTImageMapInt::Instance()->GetImageByID(ResID);
}


CRect CChatMainViewElementList::GetViewRect()
{
	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);
	if (m_wndScrollBar.IsWindowVisible())
	{
		rtClient.right -= GetSystemMetrics(SM_CXVSCROLL);
	}
	return rtClient;
}

Image* CChatMainViewElementList::GetUserImage()
{
	return NULL;
}

Image* CChatMainViewElementList::GetSendStatusImage(int nIndex)
{
	if(nIndex < 0 || nIndex > 4)
	{
		return NULL;
	}

	return m_pImgSendStatus[nIndex];
}

Image* CChatMainViewElementList::GetBubbleBottomForSendProcessImage(int nIndex)
{
	return m_pImageBubbleBottomForSendProcess[nIndex];
}

Image* CChatMainViewElementList::GetBubbleBottomForRecvProcessImage( int nIndex )
{
	return m_pImageBubbleBottomForRecvProcess[nIndex];
}


Image* CChatMainViewElementList::GetUserJoinImage( int nIndex, BOOL bUserJoin )
{
	if(nIndex > 2)
	{
		return NULL;
	}

	if(bUserJoin)
	{
		return m_pImageUserJoin[nIndex];
	}

	return m_pImageUserLeave[nIndex];
}


Image* CChatMainViewElementList::GetRecentMessageImage()
{
	return m_pImgRecentMessage;
}

Image* CChatMainViewElementList::GetRecentMessageBKImage( BOOL bNormal )
{
	if(bNormal)
	{
		return m_pImgRecentMessageBK[0];
	}

	return m_pImgRecentMessageBK[1];
}

Image* CChatMainViewElementList::GetMyBubbleImage(int nIndex)
{
	return m_pImgMyBubble[nIndex];
}

Image* CChatMainViewElementList::GetDividerImage()
{
	return m_pImageDivider;
}
								
Image* CChatMainViewElementList::GetYourProgressBarImage(int nIndex)
{
	return m_pImgYourProgress[nIndex];
}

Image* CChatMainViewElementList::GetMyProgressBarImage(int nIndex)
{
	return m_pImgMyProgress[nIndex];
}

Image** CChatMainViewElementList::GetBubbleImage(BOOL bMine)
{
	Image** p = m_pImgOtherBubble;
	if (bMine)
	{
		p = m_pImgMyBubble;
	}
	
	return p;
}

Image* CChatMainViewElementList::GetOtherBubbleImage(int nIndex)
{
	return m_pImgOtherBubble[nIndex];
}

BOOL CChatMainViewElementList::IsMouseSelection()
{
	return m_bMouseSelection;
}
CPoint CChatMainViewElementList::GetSelectionStartPoint()
{
	return m_ptSelectionStart;
}

void CChatMainViewElementList::SetCursor(int nCursor)
{
	//Set CChatMainView::m_nCursor
	m_nCursor = nCursor;
}

void CChatMainViewElementList::InvalidateElement(UIElement* pElement, BOOL bCalcSize)
{
// 	int nIndex = -1;
// 	CSingleLock l(&m_csUIElement, TRUE);
// 	for (int i = m_vcUIElement.size() - 1; i >= 0; i--)
// 	{
// 		if (m_vcUIElement[i] == pElement)
// 		{
// 			nIndex = i;
// 			break;
// 		}
// 	}
// 
// 	l.Unlock();
// 
// 	if (nIndex != -1)
// 	{
// 		UpdateElementRect(nIndex);
// 		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
// 	}

// 	if (bCalcSize)
// 	{
// 
// 		CRect rc = pElement->GetElementRect();
// 		DWORD dwFlags = pElement->GetCurrentFlags();
// 
// 		CSize sz = pElement->CalcSize(rc.TopLeft(), dwFlags);
// 		if (sz.cx != rc.Width() || sz.cy != rc.Height())
// 		{
// 			CalcUIElementRect();
// 
// 		}
// // 		UpdateView();
// 		//Invalidate(FALSE);
// 		//PostMessage(UM_ELEMENT_UPDATE, ELEMENT_UPDATE_UNIT);
// 	}
// 	else
// 	{
// 		CRect rcView = GetViewRect();
// 		//CRect rc = pElement->GetElementRect();
// 		//CPoint ptZero(0, 0);
// 		//CPoint ptOffset = ptZero - GetOffSetPoint();
// 		//rc.OffsetRect(ptOffset);
// 		InvalidateRect(rcView, FALSE);
// 		//Invalidate(FALSE);
// 		//PostMessage(UM_ELEMENT_UPDATE, ELEMENT_UPDATE_UNIT);
// 	}
}

BOOL CChatMainViewElementList::IsDrawTime( CTime& time1, CTime& time2 )
{
 	tm tmUTC1, tmUTC2;
	time1.GetGmtTm(&tmUTC1);
	time2.GetGmtTm(&tmUTC2);

	if (abs(tmUTC2.tm_min - tmUTC1.tm_min) >= 1)
	{
		return TRUE;
	}

	__int64 v = time1.GetTime() - time2.GetTime();
	if (_abs64(v) > 60)
	{
		return TRUE;
	}

	return FALSE;
}


Image* CChatMainViewElementList::GetFailMsgImage()
{
	return m_pImgSendFail;
}

Image* CChatMainViewElementList::GetFileTransferFileImage(LPCTSTR filename)
{
	CString strFile = filename;
	int nDotPos = strFile.ReverseFind(_T('.'));// .find_last_of(L".");
	CString strSuffix = _T("");
	if(nDotPos >= 0)
	{
		strSuffix = strFile.Mid(nDotPos);
	}
	//return CFTImageMap::GetFileTypeImage(this, filename);
	int nImageIdx = CFTImageMapInt::FindeImageIDByFileNameExt(strSuffix, (GetChatDisplayType() == CHAT_BUBBLE));
	return CFTImageMapInt::Instance()->GetImageByID(nImageIdx);
}

//Image* CChatMainViewElementList::GetCacheImageByFilePath(LPCTSTR pszImageFilePath)
//{
//	Image*	pImage = NULL;
//	ASSERT(pszImageFilePath);
//	if (pszImageFilePath)
//	{
//		CString strFullPath = GetAppImgFile(pszImageFilePath);
//		ImageByPathMap::iterator iter = m_imageByPathMap.find(strFullPath);
//		if (iter != m_imageByPathMap.end())
//		{
//			return iter->second;
//		}
//		pImage = new Image(strFullPath);
//		if (pImage)
//		{
//			m_imageByPathMap[strFullPath] = pImage;
//		}
//	}
//
//	return pImage;
//}

void CChatMainViewElementList::ResendChatItem( CChatItem* pChatItem )
{
	if (NMessageBox(GetParent(), LoadStringFromResource(IDS_STRING350), _T("Ntalk biz"), MB_YESNO) == IDYES)
	{
		LPChatItemInfo pInfo = pChatItem->GetChatItemInfo();
		if (pInfo)
		{
			pChatItem->SetMsgStatus(CMS_INVALID);
			pChatItem->SetSucceedCount(0);
			pChatItem->ResetFailCount();

			if ( CHAT_MSG_STICKER == pInfo->eMsgGB)
			{
				m_pChatDlg->ResendChatMsg(pChatItem->GetMsgSeq(), pChatItem->GetTid(),
					pInfo->strMsg, pInfo->cf, DEF_CHAT_MSG_TYPE_STICKER);
			}
			else if( CHAT_MSG_CHAT == pInfo->eMsgGB)
			{
				m_pChatDlg->ResendChatMsg(pChatItem->GetMsgSeq(), pChatItem->GetTid(),
					pInfo->strMsg, pInfo->cf, DEF_CHAT_MSG_TYPE_CHAT);
			}
		}
	}
}

void CChatMainViewElementList::StartFileTransfer(CChatItem* pChatItem)
{
	CChatFileItem* pChatFileItem = dynamic_cast<CChatFileItem*>(pChatItem);
	ASSERT(pChatFileItem);
	if (pChatFileItem)
	{
		LPChatItemInfo pInfo = pChatItem->GetChatItemInfo();
		ASSERT(pInfo && CHAT_MSG_FTP == pInfo->eMsgGB);
        TranslateFileInfoPtr pTranslateFileInfo = pChatFileItem->GetTranslateFileInfo();
		m_pChatDlg->StartDownloadFile(pTranslateFileInfo);
	}
}
void CChatMainViewElementList::CancelFileTransfer(CChatItem* pChatItem)
{
	CChatFileItem* pChatFileItem = dynamic_cast<CChatFileItem*>(pChatItem);
	ASSERT(pChatFileItem);
	if (pChatFileItem)
	{
		LPChatItemInfo pInfo = pChatItem->GetChatItemInfo();
		ASSERT(pInfo && CHAT_MSG_FTP == pInfo->eMsgGB);
		m_pChatDlg->CancelTransferJob(pChatFileItem->GetTranslateFileInfo()->m_nJobIndex);
	}
}

void CChatMainViewElementList::OpenHyperLink( LPCTSTR strUrl )
{
	CString strSelectUrl = strUrl;
	if (strSelectUrl.Find(_T('@')) > -1)
	{
		CXHyperLink::SendMailTo(strSelectUrl, SW_SHOWNORMAL);
	}
	else if (FALSE == CXHyperLink::UseAlreadyOpenedIE(strSelectUrl))
	{
		CXHyperLink::GotoURL(strSelectUrl, SW_SHOWNORMAL);
	}
}

// LRESULT CChatMainViewElementList::OnElementUpdate( WPARAM wParam, LPARAM lParam )
// {
// 	DWORD dwID = (DWORD)wParam;
// 	if (dwID == ELEMENT_UPDATE_SCROLL)
// 	{
// 		UpdateScrollInfo();
// 		if (!m_pChatDlg->IsScrollLocked())
// 		{
// 			ScrollToLastchatItem();
// 		}
// 		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
// 	}
// 	else if (dwID == ELEMENT_UPDATE_UNIT)
// 	{
// 		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
// 	}
// 	return 0;
// }

void CChatMainViewElementList::SelectAllItem( BOOL bSelect /*= TRUE*/ )
{
	{
		CSingleLock lModel(m_pChatModel->GetChatItemCS(), TRUE);
		int nCount = m_pChatModel->GetChatItemCount();

		if(nCount > 0)
		{
			m_nStartSelTextIndex = 0;
			m_nEndSelTextIndex = nCount - 1;
		}
		else
		{
			m_nStartSelTextIndex = m_nEndSelTextIndex = -1;
		}
		
		for (int i = 0; i < nCount; i++)
		{
			CChatItem *pChItem = (CChatItem*)m_pChatModel->GetChatItem(i);

			UIElement* pUIElement = NULL; 
			for (size_t j = 0; j < m_vcUIElement.size(); j++)
			{
				if (m_vcUIElement[j]->IsSameChatItem(pChItem))
				{
					pUIElement = m_vcUIElement[j];
					break;
				}
			}

			if (!pChItem || !pUIElement)
				continue;
			if(bSelect)
			{
				pChItem->SelectAll(pUIElement->GetTimeString());
			}
			else
			{
				pUIElement->ResetSelectRange();
			}
		}
	}

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CChatMainViewElementList::_SetScrollLock(int nCurPos, int nMax)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	if (nCurPos >=  nMax - rcClient.Height())
	{
		m_pChatDlg->SetScrollLock(false);
	}
	else
	{
		m_pChatDlg->SetScrollLock(true);
	}
}

int CChatMainViewElementList::GetChatDisplayType()
{
	return m_nChatDisplayType;
}

BOOL CChatMainViewElementList::IsDrawDate( CTime& time1, CTime& time2 )
{
	tm tmUTC1, tmUTC2;
	time1.GetGmtTm(&tmUTC1);
	time2.GetGmtTm(&tmUTC2);

	if (abs(tmUTC2.tm_mday - tmUTC1.tm_mday) >= 1)
	{
		return TRUE;
	}

	return FALSE;
}

void CChatMainViewElementList::OnTimer( UINT_PTR nIDEvent )
{
	if (CHATMAIN_TIMER == nIDEvent)
	{
		DWORD dwTick = GetTickCount();
		if (dwTick - m_dwRecentTick >= CHATMAIN_TIME_OUT)
		{
			m_strRecentMsg = _T("");

			if(m_bMouseInRecentMsgRect)
			{
				::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW)); // when recent message disappear, set cursor to I arrow
				m_bMouseInRecentMsgRect = false;
			}

			Invalidate();
		}
	}
}

Image* CChatMainViewElementList::GetDownloadImage()
{
	return m_pDownloadImage;
}

Image* CChatMainViewElementList::GetDownloadedImage()
{
	return m_pDownloadedImage;
}

Image* CChatMainViewElementList::GetReDownloadImage()
{
	return m_pDownloadImage;
}

Image* CChatMainViewElementList::GetCancelDownloadImage()
{
	return m_pCancelDownloadImage;
}

Image* CChatMainViewElementList::GetCancelSendImage()
{
	return m_pCancelSendImage;
}

void CChatMainViewElementList::SetTestChatDisplayType( int nType )
{
	m_nChatDisplayType = nType;
}


HWND CChatMainViewElementList::GetToolTipWindow()
{
	return m_hWndToolTip;
}

bool CChatMainViewElementList::IsGroupRoom()
{
	return m_pChatDlg->IsGroupRoom();
}

TOOLINFO* CChatMainViewElementList::GetToolInfo()
{
	return &m_ToolInfo;
}